--# main_program;
procedure RestoMain
--#  derives;
is
   function  Resto(Ddo, Dre: Natural) return Natural
   --# pre  Dre /= 0;
   --# return R => (for some Q in Natural => ( Ddo = Q*Dre + R and R < Dre ));
   is
      T, Z : Natural ;
   begin
      --# accept Flow, 10, "Z serve per calcolare T";
      Z := 0;
      T := Ddo;
      loop
         --# assert Ddo = Z*Dre + T;
         exit when (T < Dre);
         T := T - Dre;
         Z := Z+1;
      end loop;
      return T;
   end Resto;

   procedure Call(F1,F2: in Natural; Res : out Natural)
   --# derives Res from F1,
   --#                F2;
   --# pre  F2 /= 0;
   --# post for some Quoz in Natural => ( F1 = Quoz*F2 + Res and Res < F2 );
   is
   begin
      Res := Resto(F1,F2);
   end Call;

   -- function resto2(x,y : Natural) return Natural;
   -- Def: for some qq in Natural =>
   --      ( y <> 0 -> ( x = qq*y + rest(x,y) and rest(x,y) < y ) ) ;
   -- Th (di correttezza): y <> 0 -> Resto2(x,y) = resto2(x,y) ;
   -- prova: call2.siv 28-APR-2010, 22:59:00

   function  Resto2(Ddo, Dre: Natural) return Natural
   --# pre  Dre /= 0;
   --# return R =>
   --#     (for some Q in Natural => ( Ddo = Q*Dre + R and R < Dre ));
   is
      T, Z : Natural ;
   begin
      --# accept Flow, 10, "Z serve per calcolare T";
      Z := 0;
      T := Ddo;
      loop
         --# assert Ddo = Z*Dre + T;
         exit when (T < Dre);
         T := T - Dre;
         Z := Z+1;
      end loop;
      return T;
   end Resto2;

   procedure Call2(F1,F2: in Natural; Res : out Natural)
   --# derives Res from F1, F2;
   --# pre  F2 /= 0;
   --# post Res = resto2(F1,F2);
   is
   begin
      Res := Resto2(F1,F2);
   end Call2;
begin
   null;
end RestoMain;
