--# main_program;
procedure ProdMain
--#  derives;
is
   function Prod(X,Z: in Natural) return Natural
   --# pre X*Z<= Natural'Last;
   --# return X*Z;
   is
      P : Natural := 0;
      Y : Natural := 0;
   begin
     loop
     --# assert P=X*Y and 0<=Y and Y<=Z;
       exit when Y=Z;
       P:=P+X; Y:=Y+1;
      end loop;
      return P;
   end Prod;

   procedure Call(F1,F2: in Natural; R : out Natural)
   --# derives R from F1,
   --#                F2;
   --# post (F1*F2 <= Natural'Last and R = F1*F2) or (F1*F2 > Natural'Last and R = 0)
   is
   begin
      R:=0;
      if F2 = 0 or else F1 <= Natural'Last / F2
      then
         R := Prod(F1,F2);
      end if;
   end Call;

begin
   null;
end ProdMain;
